// ChatSDoc.cpp : implementation of the CChatSDoc class
//

#include "stdafx.h"
#include "ChatS.h"

#include "ChatSDoc.h"
#include "ServerSock.h"
#include "ClientSock.h"
#include "ChatSView.h"
#include "ProtocolUnit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChatSDoc

IMPLEMENT_DYNCREATE(CChatSDoc, CDocument)

BEGIN_MESSAGE_MAP(CChatSDoc, CDocument)
	//{{AFX_MSG_MAP(CChatSDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChatSDoc construction/destruction

CChatSDoc::CChatSDoc()
{
	// TODO: add one-time construction code here
	m_pServerSock = NULL;
}

CChatSDoc::~CChatSDoc()
{
}

BOOL CChatSDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	POSITION pos  = GetFirstViewPosition();
	ASSERT(pos!=NULL);
	m_pView = (CChatSView*) GetNextView(pos);
	ASSERT(m_pView!=NULL);

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CChatSDoc serialization

void CChatSDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CChatSDoc diagnostics

#ifdef _DEBUG
void CChatSDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CChatSDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CChatSDoc commands


void CChatSDoc::AcceptNewClient()
{
	CClientSock* pSocket = new CClientSock(this);
	if(m_pServerSock->Accept(*pSocket))
	{
		m_pView->m_sSaid += pSocket->GetClientIP() +" connected\r\n";
		m_pView->UpdateData(FALSE);
		m_client_list.AddTail(pSocket);
		pSocket->SendString("WELCOME WELCOME\r\n");
		pSocket->SetJoined(FALSE);
	}
	else
	{
		m_pView->m_sSaid += "accept failed\r\n";
		m_pView->UpdateData(FALSE);
	}
}


void CChatSDoc::ReceiveFromClient(CClientSock* pSocket)
{
	CProtocolUnit unit;   
	unit.Extract(pSocket->GetBuffer()); 
	
	if(!pSocket->IsJoined() && (unit.GetCommandID() != PU_JOIN)&&(unit.GetCommandID() != PU_LIST))
	{
		pSocket->SendString("ERROR 2 use JOIN first\r\n");
		return;
	}

	switch(unit.GetCommandID())
	{
		case PU_UNKNOWN:
			pSocket->SendString("ERROR 0 Unknown command\r\n");
			break;

		case PU_SAY:
		{
			CString cMesg="SAY "+pSocket->GetClientNick()+
				" " + unit.GetParam() + " " + unit.GetText()+"\r\n";
			SayToAll(cMesg);
			cMesg="<"+pSocket->GetClientNick()+">"+" "+ unit.GetParam() + " " + unit.GetText()+"\r\n";
			m_pView->ScrollEdit();
			m_pView->m_sSaid+=cMesg;
			m_pView->UpdateData(FALSE);
			break;
		}

		case PU_WHISPER: 	//senderror
		{
			CClientSock* pTargetSock = GetSocketByNick(unit.GetParam());
			if(!pTargetSock)
				pSocket->SendString("ERROR 3 "+unit.GetParam()+"\r\n");
			else
				pTargetSock->SendString("WHISPER "+pSocket->GetClientNick()+" "+unit.GetText()+"\r\n");
			break;
		}

		case PU_JOIN:
		{
			if(!NickAlreadyIs(unit.GetParam()) && (unit.GetParam().GetLength()>0))
			{
				pSocket->SetClientNick(unit.GetParam());
				CString cMesg="JOIN "+pSocket->GetClientNick()+" joined\r\n";
				pSocket->SetJoined();
				SayToAll(cMesg);
				cMesg=pSocket->GetClientNick()+" joined\r\n";
				m_pView->ScrollEdit();
				m_pView->m_sSaid+=cMesg;
				m_pView->UpdateData(FALSE);
				m_pView->ShowClientNicks();
			}
			else
			{
				CString cMesg = "ERROR 1 This nick is already in use or bad nick, try again\r\n";
				pSocket->SendString(cMesg);
			}
			break;
		}

		case PU_NICK:
		{
			if (!NickAlreadyIs(unit.GetParam()))
			{
				CString sOldNick = pSocket->GetClientNick();
				pSocket->SetClientNick(unit.GetParam());
				SayToAll("NICK "+sOldNick+" "+pSocket->GetClientNick()+"\r\n");
				m_pView->ScrollEdit();
				m_pView->m_sSaid+=sOldNick+" is now known as "+pSocket->GetClientNick()+"\r\n";
				m_pView->UpdateData(FALSE);
				m_pView->ShowClientNicks();
			}
			else
			{
				CString cMesg="ERROR 1 This nick is already in use, try again\r\n";
				pSocket->SendString(cMesg);
			}
			break;
		}

		case PU_BYE:
		{
			CString cMesg="BYE "+pSocket->GetClientNick()+" \r\n";
			SayToAll(cMesg);
			pSocket->SetJoined(FALSE);
			cMesg=pSocket->GetClientNick()+" said BYE\r\n";
			m_pView->ScrollEdit();
			m_pView->m_sSaid+=cMesg;
			m_pView->UpdateData(FALSE);
			m_pView->ShowClientNicks();
			break;
		}

		case PU_LIST:
		{
			CString sList = GetNickList();
			pSocket->SendString("LIST "+sList+"\r\n");
			break;
		}
				
	}; 
}



BOOL CChatSDoc::StartServer(UINT nPort)
{
	if(m_pServerSock)
	{
		m_pView->ScrollEdit();
		m_pView->m_sSaid+="Server is already running\r\n";
		m_pView->UpdateData(FALSE);
		return FALSE;
	}

	m_pServerSock = new CServerSock(this);
	if(!m_pServerSock)
	{
		m_pView->ScrollEdit();
		m_pView->m_sSaid+="Couldn't start server, try again\r\n";
		m_pView->UpdateData(FALSE);
		return FALSE;
	}

	if(!m_pServerSock->Create(nPort))
	{
		m_pView->ScrollEdit();
		m_pView->m_sSaid+="Couldn't start server, try again\r\n";
		m_pView->UpdateData(FALSE);
		return FALSE;
	}

	if(!m_pServerSock->Listen())
	{
		m_pView->ScrollEdit();
		m_pView->m_sSaid+="Couldn't start server, try again\r\n";
		m_pView->UpdateData(FALSE);
		return FALSE;
	}
	m_pView->ScrollEdit();
	m_pView->m_sSaid+="Server started...\r\n";
	m_pView->UpdateData(FALSE);

	return TRUE;
}


void CChatSDoc::StopServer()
{
	if(m_pServerSock)
	{
		
		CString cMesg="Server is going to shut down";
		while(!m_client_list.IsEmpty())
		{
			CClientSock* pSocket = (CClientSock*) m_client_list.RemoveHead();
			pSocket->SendString(cMesg);
			pSocket->Close();
			delete pSocket;
		}

		m_pServerSock->Close();
		delete m_pServerSock;
		m_pServerSock = NULL;
		m_pView->ScrollEdit();
		m_pView->m_sSaid+="Server down...\r\n";
		m_pView->UpdateData(FALSE);
	}
}


BOOL CChatSDoc::IsServerRunning()
{
	return m_pServerSock != NULL;
}


void CChatSDoc::SayToAll(CString sMesg)
{
	POSITION pos=m_client_list.GetHeadPosition();
	while(pos)
	{
		CClientSock* pSocket=(CClientSock*)m_client_list.GetNext(pos);
		if (pSocket)
			pSocket->SendString(sMesg);
	}
}

BOOL CChatSDoc::NickAlreadyIs(CString sNick)
{
	POSITION pos=m_client_list.GetHeadPosition();
	while(pos)
	{
		CClientSock* pSocket=(CClientSock*)m_client_list.GetNext(pos);
		if (sNick == pSocket->GetClientNick())
			return TRUE;
	}
	return FALSE;
}

CString CChatSDoc::GetNickList() const
{
	CString sList = "";
	POSITION pos = m_client_list.GetHeadPosition();

	while(pos)
	{
		CClientSock* pSocketL = (CClientSock*)m_client_list.GetNext(pos);
		if(pSocketL && pSocketL->IsJoined())
			sList += pSocketL->GetClientNick() + " ";
	}

	return sList;
}

void CChatSDoc::ClientClose(CClientSock *pSocket)
{
	m_pView->ScrollEdit();
	m_pView->m_sSaid += pSocket->GetClientIP() +" disconnected\r\n";
	m_pView->UpdateData(FALSE);

	POSITION pos = m_client_list.Find(pSocket);
	if(pos)
	{
		m_client_list.RemoveAt(pos);
		SayToAll("DISCONNECT "+pSocket->GetClientNick()+" disconnected\r\n");
		delete pSocket;
		m_pView->ShowClientNicks();
	}
}

CClientSock* CChatSDoc::GetSocketByNick(const CString &rsNick)
{
	POSITION pos = m_client_list.GetHeadPosition();

	while(pos)
	{
		CClientSock* pSocketL = (CClientSock*)m_client_list.GetNext(pos);
		if(pSocketL && (pSocketL->GetClientNick() == rsNick))
			return pSocketL;
	}

	return NULL;
}
