// ClientSock.cpp : implementation file
//

#include "stdafx.h"
#include "ChatS.h"
#include "ClientSock.h"
#include "ClientSock.h"
#include "ChatSDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MY_BUFFER_LENGTH 255

/////////////////////////////////////////////////////////////////////////////
// CClientSock

CClientSock::CClientSock()
{
}

CClientSock::CClientSock(CChatSDoc* pDoc)
{
	ASSERT(pDoc!=NULL);
	m_pDoc = pDoc;
	m_sNick = "";
	m_sReadyLine = "";
	m_sReceiveBuffer = "";
	m_bJoined = FALSE;
}

CClientSock::~CClientSock()
{
}

// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CClientSock, CSocket)
	//{{AFX_MSG_MAP(CClientSock)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// CClientSock member functions

void CClientSock::OnReceive(int nErrorCode) 
{
	static char buffer[MY_BUFFER_LENGTH];
	int nCount;

	CSocket::OnReceive(nErrorCode);

	
	nCount = Receive(buffer,MY_BUFFER_LENGTH);

	//Send(buffer,nCount); // echo

	buffer[nCount] = '\0';
	m_sReceiveBuffer += buffer;

	int nPos;
	
	while( (nPos = m_sReceiveBuffer.Find("\r\n")) >= 0) 
	{
		m_sReadyLine = m_sReceiveBuffer.Left(nPos);
		m_pDoc->ReceiveFromClient(this);
		m_sReceiveBuffer = m_sReceiveBuffer.Mid(nPos+2);
	}
}

CString CClientSock::GetBuffer() const
{
	return m_sReadyLine;
}

BOOL CClientSock::SendString(const CString& rsString)
{

	if( Send(rsString,rsString.GetLength()) < 0 )
	{
		// error
		return FALSE;
	}

	return TRUE;
}

CString CClientSock::GetClientIP()
{	
	CString sName;
	UINT nPort;

	if(!GetPeerName(sName,nPort))
		sName = "[CCltSocket ERROR: GetPeerName failed]";
	else
	{
		CString sPort;
		sPort.Format("  port:%i ",nPort);
		sName += sPort;
	}

	return sName;
}

CString CClientSock::GetClientNick() const
{
  return m_sNick;
}

void CClientSock::SetClientNick(const CString &rsNick)
{
	m_sNick = rsNick;
}

BOOL CClientSock::IsJoined() const
{
	return m_bJoined;
}

void CClientSock::SetJoined(BOOL bJoined /* = TRUE */)
{
	m_bJoined = bJoined;
}

void CClientSock::OnClose(int nErrorCode) 
{
	// TODO: Add your specialized code here and/or call the base class
	CSocket::OnClose(nErrorCode);
	m_pDoc->ClientClose(this);
}
